import java.io.File;
import java.io.IOException;
import java.util.Scanner;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * Created by thook on 10/7/15.
 */
public class HamletParser {

    private String hamletData;

    public HamletParser(){
        this.hamletData = loadFile();
    }

    private String loadFile(){
        ClassLoader classLoader = getClass().getClassLoader();
        File file = new File(classLoader.getResource("hamlet.txt").getFile());
        StringBuilder result = new StringBuilder("");

        try(Scanner scanner = new Scanner(file)){
            while(scanner.hasNextLine()){
                String line = scanner.nextLine();
                result.append(line).append("\n");
            }
        }catch(IOException e){
            e.printStackTrace();
        }

        return result.toString();
    }

    public String getHamletData(){
        return hamletData;
    }

    private Matcher matchingwords(String regex){
        Pattern pattern = Pattern.compile(regex, Pattern.CASE_INSENSITIVE);
        Matcher matcher = pattern.matcher(this.hamletData);
        return  matcher;
    }

    public void changeHamletToLeon() {

        Matcher matcher = matchingwords("hamlet");
        hamletData = matcher.replaceAll("Leon");
    }

    public void changeHoratioToTariq() {
        Matcher matcher = matchingwords("horatio");
        hamletData = matcher.replaceAll("Tariq");
    }

    public boolean findHoratio() {
        Matcher matcher = matchingwords("horatio");
        return matcher.find();
    }

    public boolean findHamlet() {
        Matcher matcher = matchingwords("hamlet");
        return matcher.find();
    }
}
